//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ^wb_
 * @author Junpee
 */

#ifndef SPORTS_MEETING_H_
#define SPORTS_MEETING_H_

#include <Framework/System/SceneFramework.h>

namespace Lamp{
	class SceneNode;
	class AnimationSet;
}

//------------------------------------------------------------------------------
/**
 * ^
 */
class SportsMeeting : public SceneFramework{
public:
	/**
	 * RXgN^
	 */
	SportsMeeting();

	/**
	 * 
	 * @return ɐtrueԂ
	 */
	virtual bool initialize();

	/**
	 * V[̃[h
	 * @param sceneName V[
	 * @return true
	 */
	virtual bool loadScene(const String& sceneName);

	/**
	 * s
	 */
	virtual void run();

	/**
	 * _O
	 */
	virtual void renderSetup();

	/**
	 * `
	 */
	virtual void drawInformation();

protected:
	/// V[PX̐ݒ
	virtual void sequenceSetup();

	/**
	 * i[ZbgAbv
	 * @param animation Aj[V
	 * @param count Aj[VJEg
	 */
	virtual void runnerSetup(Animation* animation, int count);

private:
	// i[ZbgJEg
	static const int runnerSetCount_ = 6;
	// i[Zbg
	AnimationSet* runnerSet_[runnerSetCount_];
	// i[oX
	AnimationSet* runnerPath_;
	// V
	SceneNode* tenkyuu_;
	// [v^C}
	float loopTimer_;
	// XRA
	int score_;
	// ŏIXRA
	int lastScore_;
	// ^CXP[
	int timeScale_;

};

//------------------------------------------------------------------------------
#endif // End of SPORTS_MEETING_H_
//------------------------------------------------------------------------------

