//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * Opwb_
 * @author Junpee
 */

#ifndef TRIANGLE_INTERSECTION_H_
#define TRIANGLE_INTERSECTION_H_

namespace Lamp{

class Triangle;

//------------------------------------------------------------------------------
/**
 * Op
 */
class TriangleIntersection{
public:
	//--------------------------------------------------------------------------
	// _
	//--------------------------------------------------------------------------
	/**
	 * _
	 * @param triangle Op
	 * @param point _
	 * @param range ͈
	 * @return Ătrue
	 */
	static bool intersect(const Triangle& triangle, const Vector3& point,
		float range = Math::epsilon);

	//--------------------------------------------------------------------------
	// Op
	//--------------------------------------------------------------------------
	/**
	 * Op
	 * @param triangle0 Op
	 * @param triangle1 Op
	 * @return Ătrue
	 */
	static bool intersect(const Triangle& triangle0, const Triangle& triangle1);

private:
	//--------------------------------------------------------------------------
	// RXgN^̉B
	TriangleIntersection();

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of TRIANGLE_INTERSECTION_H_
//------------------------------------------------------------------------------
