//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 񃊃Xiwb_
 * @author Junpee
 */

#ifndef TEST_STRING_LISTENER_H_
#define TEST_STRING_LISTENER_H_

#include <LampUnit/TestListener.h>

namespace Lamp{
	class Logger;
}

namespace LampUnit{

//------------------------------------------------------------------------------
/**
 * 񃊃Xi
 */
class TestStringListener : public TestListener{
public:
	/**
	 * RXgN^
	 * @param fileName Ot@CBNULLƃOc܂B
	 */
	TestStringListener(const char* fileName = "UnitTestLog.txt");

	/**
	 * fXgN^
	 */
	virtual ~TestStringListener();

	/**
	 * eXgJn
	 * @param test JneXg
	 */
	virtual void startTest(Test* test);

	/**
	 * s̒ǉ
	 *
	 * \bhIłfailurȅ񂪕KvȏꍇfailureRs[B
	 * @param failure seXg̏
	 */
	virtual void addFailure(const TestFailure& failure);

	/**
	 * eXgI
	 * @param test IeXg
	 */
	virtual void endTest(Test* test);

	/**
	 * o
	 * @param string o͕
	 */
	virtual void print(const char* string);

	/**
	 * tH[}bgo
	 *
	 * ϒɑΉfobOo̓\bhB
	 * @param format tH[}bg
	 * @param ... ϒ
	 * @return o͕
	 */
	virtual void printFormat(const char* format, ...);

private:
	// eXgJEg
	int testCount_;
	// K[
	Lamp::Logger* logger_;

	// ő啶
	static const int maxStringLength_ = 1024;

};

//------------------------------------------------------------------------------
} // End of namespace LampUnit
#endif // End of TEST_STRING_LISTENER_H_
//------------------------------------------------------------------------------
